package de.ivu.elect.presentation.ergebnis.table;

import java.math.BigDecimal;
import java.util.function.Function;

import de.ivu.elect.business.ergebnis.entity.GewinnerUnterlegenerStimmendifferenzSearchResult;
import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.jee.presentation.dynamictable.ColumnType;
import de.ivu.elect.presentation.system.PercentUtil;

/**
 *  on 02.06.2015.
 */
public class GewinnerUnterlegenerStimmendifferenzAnteilColumn extends AbstractGewinnerUnterlegenerStimmendifferenzColumn {

  private final Function<GewinnerUnterlegenerStimmendifferenzSearchResult, Long> stimmenFct;

  public GewinnerUnterlegenerStimmendifferenzAnteilColumn(Function<GewinnerUnterlegenerStimmendifferenzSearchResult, Long> stimmenFct, Messages messages) {
    super(messages);
    this.stimmenFct = stimmenFct;
  }

  @Override
  public Object getValue(GewinnerUnterlegenerStimmendifferenzSearchResult gewinnerUnterlegenerStimmendifferenzSearchResult) {
    Long stimmen = stimmenFct.apply(gewinnerUnterlegenerStimmendifferenzSearchResult);
    Long gesamt = gewinnerUnterlegenerStimmendifferenzSearchResult.getAnzahlStimmenInsgesamt();

    BigDecimal percent = PercentUtil.percent01(gesamt, stimmen);

    return percent;
  }

  @Override
  public String getHeader() {
    return getMessage("gewinner.unterlegener.stimmendifferenz.anteil");
  }

  @Override
  public ColumnType getType() {
    return ColumnType.DECIMAL_ONE_FRACTION_DIGIT_PERCENTAGE;
  }
}
